## libzypp 17.37.18

=== debian/changelog ===
libzypp (17.37.18-1) unstable; urgency=medium

  * Update upstream source from tag 'upstream/17.37.18'
  * Backport patch to fix build with RPM 6 (Closes: #1120826)
  * d/rules: skip RpmPkgSigCheck_test, not compatible with RPM 6
  * d/copyright: update paths for new source layout

 -- Luca Boccassi <bluca@debian.org>  Mon, 08 Dec 2025 23:36:19 +0000
