=== debian/changelog ===
libzypp (17.38.1-1build1) resolute; urgency=medium

  * No-change rebuild for boost 1.90.

 -- Matthias Klose <doko@ubuntu.com>  Wed, 04 Feb 2026 14:23:48 +0100

libzypp (17.38.1-1) unstable; urgency=medium

  * Update upstream source from tag 'upstream/17.38.1'
  * Drop patches, merged upstream
  * Drop priority from d/control, now defaults to optional
  * Drop Rules-Requires-Root, now defaults to no
  * Bump Standards-version to 4.7.3
  * Install new usr/etc/zypp/zypp.conf file

 -- Luca Boccassi <bluca@debian.org>  Thu, 22 Jan 2026 10:36:38 +0100
