## libzypp 17.38.2

=== CMakeLists.txt ===
--- 
+++ 
@@ -42,6 +42,7 @@
 
 OPTION (BUILD_LIBZYPP "Build of the classic libzypp library" ON)
 OPTION (BUILD_LIBZYPPNG "Build of the next gen libzypp library" ON)
+OPTION (KEEP_LEGACY_ZYPPCONF "Install the vendor zypp.conf in /etc too (ONLY LEGACY SYSTEMS WANT THIS)" OFF)
 #--------------------------------------------------------------------------------
 SET (have_system x)
 
@@ -268,5 +269,3 @@
 target_include_directories( zypp_initial_compiler_flags INTERFACE ${LibSolv_INCLUDE_DIRS} )
 
 pkg_search_module(GPGME gpgme>=1.8.0)
-IF ( GPGME_FOUND )
-  MESSAGE(STATUS "Found gpgme ${GPGME_VERSION}" )
