=== zypp/CMakeLists.txt ===
--- 
+++ 
@@ -71,7 +71,11 @@
 
 MESSAGE(STATUS "zypp.conf will be installed in ${ZYPPCONFDIR}/zypp")
 INSTALL( FILES ${LIBZYPP_SOURCE_DIR}/zypp.conf DESTINATION ${ZYPPCONFDIR}/zypp )
+IF ( KEEP_LEGACY_ZYPPCONF )
+INSTALL( FILES ${LIBZYPP_SOURCE_DIR}/zypp.conf.LEGACY DESTINATION ${SYSCONFDIR}/zypp/ RENAME zypp.conf )
+ELSE()
 INSTALL( FILES ${LIBZYPP_SOURCE_DIR}/zypp.conf.README DESTINATION ${SYSCONFDIR}/zypp )
+ENDIF()
 
 MESSAGE(STATUS "needreboot will be installed in ${SYSCONFDIR}/zypp/")
 INSTALL( FILES ${LIBZYPP_SOURCE_DIR}/needreboot DESTINATION ${SYSCONFDIR}/zypp )
