=== zypp/tests/parser/inifile/CMakeLists.txt ===

ADD_TESTS(inidict iniparser EconfDict)
