=== debian/changelog ===
libzypp (17.38.2-1build1) resolute; urgency=medium

  * No-change rebuild for gpgme1.0 2.0

 -- Ural Tunaboyu <ural.tunaboyu@canonical.com>  Fri, 20 Feb 2026 19:46:45 +0000

libzypp (17.38.2-1) unstable; urgency=medium

  * Update upstream source from tag 'upstream/17.38.2'

 -- Luca Boccassi <bluca@debian.org>  Wed, 04 Feb 2026 15:07:28 +0000
